import json
import os
import pymysql


class HicDatabase:

    def __init__(self, db_type="gcloud_mysql_live"):  # gcloud_mysql
        # if db_type == "gcloud_mysql_live":
        #     print("benutze live DB!!!")

        self.db_type = db_type

        # local sqlite3 db settings:
        self.sqlite3_file = "application/db.sqlite3"

        # gcloud mysql db settings:
        self.gcloud_mysql_db_user = "root"
        self.gcloud_mysql_db_password = "1234"
        self.gcloud_mysql_db_host = '35.198.178.12'
        self.gcloud_mysql_db_name = "mydb"
        self.gcloud_mysql_db_connection_name = "hicandidate-socialtelligence:europe-west3:mysql"
        self.gcloud_mysql_db_unix_socket = '/cloudsql/{}'.format(self.gcloud_mysql_db_connection_name)

        self.local_mysql_db_host = "127.0.0.1"
        self.local_mysql_db_user = "root"
        self.local_mysql_db_password = "1234"
        self.local_mysql_db_name = "mydb"

    def sql(self, sql, args=None, download_file=False, return_last_row_id=False):

        fetch = []
        description = []
        last_row_id = None

        if "gcloud_mysql" in self.db_type:
            if os.environ.get('RUNNING_IN_GCLOUD') == 'True':
                # wenn auf gcloud:
                conn = pymysql.connect(user=self.gcloud_mysql_db_user,
                                       password=self.gcloud_mysql_db_password,
                                       unix_socket=self.gcloud_mysql_db_unix_socket,
                                       db=self.gcloud_mysql_db_name)
            else:
                if self.db_type == "gcloud_mysql_live":
                    # remote Verbindung zu gcloud db:
                    conn = pymysql.connect(user=self.gcloud_mysql_db_user,
                                           password=self.gcloud_mysql_db_password,
                                           host=self.gcloud_mysql_db_host,
                                           db=self.gcloud_mysql_db_name)
                else:
                    # lokale mysql db:
                    conn = pymysql.connect(user=self.local_mysql_db_user,
                                           password=self.local_mysql_db_password,
                                           host=self.local_mysql_db_host,
                                           db=self.local_mysql_db_name)

            with conn.cursor() as cursor:
                if args is not None:
                    cursor.execute(sql, args)
                else:
                    cursor.execute(sql)

                fetch = cursor.fetchall()
                description = cursor.description
                if return_last_row_id:
                    last_row_id = cursor.lastrowid
            conn.commit()
            conn.close()

            if download_file:
                return fetch

        result = []
        column_names = []
        if description is None:
            if return_last_row_id:
                return result, last_row_id
            return result
        for name in description:
            column_names.append(name[0])
        for element in fetch:
            json_element = {}
            for i in range(len(element)):
                if type(element[i]) == bytes:
                    if element[i] == bytes(True):
                        json_element.update({column_names[i]: True})
                    else:
                        json_element.update({column_names[i]: False})
                else:
                    json_element.update({column_names[i]: element[i]})
            result.append(json_element)
        if return_last_row_id:
            return result, last_row_id
        return result


if __name__ == "__main__":
    print("")
